/* Generated by powerful Codeforces Tool
 * Author: xxxodarap
 * Time: 2023-09-02 20:35
**/

#include<bits/stdc++.h>
using namespace std;
namespace R = std::ranges;

#define F(i, a, e) for(ll i = (a); i < (e); i++)
#define R(i, e) F(i, 0, e)

typedef long long ll;
typedef double lf;
typedef complex<lf> cp;
typedef pair<int, int> pii;


template<class T> bool ckmin(T& a, const T& b) { return b < a ? a = b, 1 : 0; }
template<class T> bool ckmax(T& a, const T& b) { return a < b ? a = b, 1 : 0; }


const lf PI = acos(-1), EPSI = 1e-9;

mt19937 rng(chrono::steady_clock::now().time_since_epoch().count());


// =============== Solution section ===============
const ll MAXD = 100 + 5;
/* const ll INF = 1LL << 60; */

ll N, M, L;

const int SOURCE = 0;
const int SINK = 1;
const int domeOffset = 2;
const int shelterOffset = domeOffset + MAXD;
int dome(int i){ return domeOffset + i; }
int shelter(int i){ return shelterOffset + i; }

const int MAXN = shelterOffset + MAXD;


const int INF = 1 << 30;
struct edge {
  int v, w, c, f;
};
vector<edge> edgelist;
vector<int> edgeind[MAXN], ptr, dis;
int s, t;
void addedge(int v, int w, int c) {
  edgeind[v].push_back(edgelist.size());
  edgelist.push_back({v, w, c, 0});
  edgeind[w].push_back(edgelist.size());
  edgelist.push_back({w, v, 0, 0});
}
bool bfs_din() {
  dis.assign(MAXN, -1);
  dis[s] = 0;
  queue<int> q({s});
  while (!q.empty() && dis[t] == -1) {
    int v = q.front(); q.pop();
    for (int ei : edgeind[v]) {
      edge e = edgelist[ei];
      if (dis[e.w] == -1 && e.f < e.c) {
        q.push(e.w);
        dis[e.w] = dis[v] + 1;
      }
    }
  }
  return dis[t] != -1;
}
int dfs_din(int v = s, int mf = INF) {
  if (!mf || v == t)
    return mf;
  for(;ptr[v] < ssize(edgeind[v]); ptr[v]++) {
    int ei = edgeind[v][ptr[v]];
    edge e = edgelist[ei];
    if (dis[e.w] != dis[v] + 1)
      continue;
    int tf = dfs_din(e.w, min(mf, e.c-e.f));
    if (tf) {
      edgelist[ei].f += tf;
      edgelist[ei ^ 1].f -= tf;
      return tf;
    }
  }
  return 0;
}
ll dinic(){
  ll flow = 0;
  while(1){
    if(!bfs_din()) break;
    ptr.assign(MAXN, 0);
    while(int tf = dfs_din()) flow += tf;
  }
  return flow;
}

// floyd warshall - from reference
vector<vector<ll>> d;
bool floyd_warshall(int n){
  for(int k = 0; k < n; k++)
    for(int i = 0; i < n; i++)
      for(int j = 0; j < n; j++)
        if(d[i][k] != INF && d[k][j] != INF)
          d[i][j] =
            min(d[i][j], d[i][k] + d[k][j]);
  for(int i = 0; i < n; i++)
    if(d[i][i] < 0) return 1;
  return 0;
}



void solve(){
    // Code goes here ...
    cin >> N >> M >> L;
    
    d.assign(MAXD, vector<ll>(MAXD, INF));
    R(i,N) d[i+1][i+1] = 0;

    int v, w, c;
    R(i, M){
        cin >> v >> w >> c;
        d[v][w] = d[w][v] = c;
    }
    floyd_warshall(N + 1);

    R(i, MAXD)
        R(j, MAXD)
            if(d[i][j] < L)
                addedge(dome(i), shelter(j), INF);


    int people;
    R(i, N){
        cin >> people;
        addedge(SOURCE, dome(i + 1), people);
    }
    R(i, N){
        cin >> people;
        addedge(shelter(i + 1), SINK, people);
    }

    s = SOURCE;
    t = SINK;
    ll res = dinic();

    cout << res << endl;

    // cleanup
    edgelist.clear();
    R(i,MAXN) edgeind[i].clear();
}


// =============== Main section ===============
int main(){
    ios_base::sync_with_stdio(0); cin.tie(0);
    cout << setprecision(12); // << fixed;

    string rest;
    while(cin.peek() != char_traits<char>::eof()){
        solve();
        getline(cin, rest);
    }

    return 0;
}
        
